// MUUDPICDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MUUDPIC.h"
#include "MUUDPICDlg.h"
#include "ConnectDlg.h"
#include <linklist.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMUUDPICDlg dialog

CMUUDPICDlg::CMUUDPICDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMUUDPICDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMUUDPICDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMUUDPICDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMUUDPICDlg)
	DDX_Control(pDX, IDC_TOTALCLIENTS, m_totcli);
	DDX_Control(pDX, IDC_BYTESWRITTEN, m_write);
	DDX_Control(pDX, IDC_BYTESREAD, m_read);
	DDX_Control(pDX, IDC_MESSAGEBOX, m_msgbox);
	DDX_Control(pDX, IDC_NAMEBOX, m_namebox);
	DDX_Control(pDX, IDC_CHATBOX, m_chatbox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMUUDPICDlg, CDialog)
	//{{AFX_MSG_MAP(CMUUDPICDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, OnDisconnect)
	ON_BN_CLICKED(IDC_BUTTON1, OnLogon)
	ON_BN_CLICKED(IDC_BUTTON3, OnQuit)
	ON_BN_CLICKED(IDC_SENDBUTTON, OnSendbutton)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMUUDPICDlg message handlers

BOOL CMUUDPICDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
  m_connection.SetDialog(this);
  
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMUUDPICDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMUUDPICDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMUUDPICDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMUUDPICDlg::OnDisconnect() 
{
  m_connection.Disconnect();
  DisplayLine("Disconnected from server");
  m_totcli.SetWindowText("");
}

void CMUUDPICDlg::OnLogon() 
{
  m_totcli.SetWindowText("Total Clients: ?");
  if (m_connection.Connect(m_serverloc, m_cliname))
    CDialog::OnCancel();
}

void CMUUDPICDlg::OnQuit() 
{
  OnDisconnect();
  CDialog::OnCancel();
}

void CMUUDPICDlg::UpdateStats()
{
  CString text;
  text.Format("Bytes Written: %i", gout);
  m_write.SetWindowText(text);

  text.Format("Bytes Read: %i", gin);
  m_read.SetWindowText(text);
}

void CMUUDPICDlg::SetServerLocation(const sockaddr_in &loc)
{
  m_serverloc = loc;
}

void CMUUDPICDlg::DisplayLine(const CString& msg)
{
  //Append the text
  m_chatbox.SetSel(m_chatbox.GetWindowTextLength(), -1);
  CString temp(msg);
  temp += "\r\n";
  m_chatbox.ReplaceSel(temp);
  //Scroll the box
  CPoint point = m_chatbox.PosFromChar(m_chatbox.GetWindowTextLength());
  CRect rect; m_chatbox.GetClientRect(rect);
  while (point.y > rect.bottom) {
    m_chatbox.LineScroll(1);
    point = m_chatbox.PosFromChar(m_chatbox.GetWindowTextLength());
  }
}

void CMUUDPICDlg::SetClientName(const CString &name)
{
  m_cliname = name;
}

void CMUUDPICDlg::ClearClientList()
{
  m_namebox.SetWindowText("");
  m_totcli.SetWindowText("");
}

void CMUUDPICDlg::ClearChatLog()
{
  m_chatbox.SetWindowText("");
}

void CMUUDPICDlg::UpdateClients(LinkList<CClient>* clients) {
  CString win(""), temp("");
  clients->SetToStart();
  int l = clients->Length();
  for (int c=0; c<l; c++) {
    CClient *cli = clients->_GetNext();
    temp.Format("%s (%i)\r\n", cli->name, cli->pingtime);
    win += temp;
    clients->_Advance();
  }
  m_namebox.SetWindowText(win);
  win.Format("Total Clients: %i", clients->Length());
  m_totcli.SetWindowText(win);
}

void CMUUDPICDlg::OnSendbutton() 
{
  CString msg;
  m_msgbox.GetWindowText(msg);
  if (msg.GetLength() > 0)
    m_connection.Talk(msg);
  m_msgbox.SetWindowText("");
}

void CMUUDPICDlg::OnClose() 
{
  OnQuit(); //Disconnect from server n stuf
	CDialog::OnClose();
}
